<?php
  //============================================================================
  // DirCaster 0.9c, released 08/20/2007. http://www.DirCaster.org
  //============================================================================
  // Open Source code but please leave all references to prior work intact
  // when making changes.
  //
  // Current maintainer: Dr. Bill Bailey - DrBill@DirCaster.org
  //
  // Based on the original DirCaster by Ryan King (http://www.shadydentist.com)
  // ID3v2.x tag support added by Warren Stone <fasttr@gmail.com> and
  // utilizing getid3 library by James Heinrich <info@getid3.org>,
  // http://www.getid3.org. iTunes specific tag support by Warren Stone
  // need to include the code to read id3 tags
  // also reads lots of different formats
  // we'll implement mp3, mpa (quicktime), asf (wma) and riff (wav/avi)
  // alter the path to your getid3 directory location
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.9c
  //============================================================================
  // 2007-08-20 - Henry L. Ratliff - ratman@houston.rr.com
  //  . added feature to allow setting enclosurePrefix variable to allow Stats
  //    processing for external providers like TechPodcasts and Blubrry from Raw
  //    Voice Media
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.9b
  //============================================================================
  // 2007-04-09 - Henry L. Ratliff - ratman@houston.rr.com
  //  . added in a guid change to allow for multiple files that had the same
  //    file date in the feed, and identifies tham as "false" for permalinks
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.9a
  //============================================================================
  // 2007-04-04 - Henry L. Ratliff - ratman@houston.rr.com
  //  . added a test so that the ?ft=[filetype] would display ONLY files that
  //    are listed in the "sftypes" list
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.9
  //============================================================================
  // 2007-03-28 - Henry L. Ratliff - ratman@houston.rr.com
  //  . Revised item GUID tag to be more unique (user forum request)
  //  . Added channel keyword tag (user forum request)
  //  . Aligned XML tag indent. Looks better when reviewing raw XML
  //  . Added parameter to allow the selection of a single file type
  //    dircaster.php?ft=[filetype]
  //    Example
  //     1. The default is no change
  //        webroot.../dircaster.php
  //         uses software define file types  "(.mp3 .m4a .m4b .asf .wma .avi .mov .mp4)"
  //     2. Select all occurrences of a single file type in the directory
  //        overrides file types in 1 above
  //         webroot...dircaster.php?ft=mp4
  //          or
  //         webroot.../dircaster.php?ft=mp3
  //        (no periods in front of file type)
  //        Any one of the file types in 1 above can be used
  //        This allows the feed to store multiple types in one directory,
  //        and allows the subscriber to select only one type
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.8a
  //============================================================================
  // 2007-01-09 - Henry L. Ratliff - ratman@houston.rr.com
  //  . Added logic to obtain <item> overrides from a text file
  //    See the override.1st file for details
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.7b
  //============================================================================
  // 2007-01-03 - Dr. Bill Bailey - DrBill@DirCaster.org
  //  . Fixed the same problem as "pubDate" for "LastBuildDate" in iTunes Feed
  //    2007-01-03 Dr. Bill Bailey
  //
  //============================================================================
  // ChangeLog for DirCaster Version 0.7a
  //============================================================================
  // 2006-12-25 -  Henry L. Ratliff ratman@houston.rr.com
  //  . Fixed several PHP Notice errors issued when error level set to ALL
  //  . Patched occasion where single digit day in pubdate sometimes
  //    displayed for example '  1' instead of ' 01'. new function fixDat()
  //  . Substituted RSS title tag value with file name when id3 title value
  //    is empty. stripType() drops the file extension
  //  . Corrected raw '&' in RSS title tag (use '&amp;' instead)
  //  . Fixed variable name error which caused, the logic to produce only
  //    a set number of feeds, not to work.  Controlled by $maxFeeds.
  //
  // Many, many thanks to Henry from the DirCaster Maintainer!
  //============================================================================
  // DirCaster specific variables (Change the items below to match YOUR feed)
  //============================================================================
  //
  // Podcast Title Variable
  $titleTAG       = "Dr. Bill: The Computer Curmudgeon";
  // Podcast Discription
  $descriptionTAG = "Tech Tips, Tech News, the Web and other various musings from Dr. Bill Bailey at Dr. Bill Bailey.NET.  Join Dr. Bill as he makes pointed, funny, and sometimes, controversial observations on Tech Life.";
  // Your Website URL
  $linkTAG        = "http://www.DrBill.CC";
  // For iTunes "New Feed" feature - to change your URL for the feed - should it
  // ever be necessary - also set the "$NEWfeedURL_ON" value to "yes" to
  // activate it.
  $NEWfeedURL     = "http://podcast.DrBill.CC/dircaster.php";
  $NEWfeedURL_ON  = "no";
  // Your Copyright String
  $copyrightTAG   = "Dr. Bill Bailey";
  // Podcast Language Tag
  $languageTAG    = "en-us";
  // Site Webmaster E-mail Address
  $webMasterTAG   = "DrBill@DrBill.CC";
  // Give The DirCaster Project some "props!"
  $generatorTAG   = "DirCaster V0.9c - www.DirCaster.org";
  // "Time to Live"
  $ttlTAG         = "60";
  // Your image should be 144 by 144 pixels - (gif, jpg, or png)
  $rssImageUrlTAG   = "http://www.DrBill.CC/images/DrBillImage144.gif";
  // Image Tag
  $rssImageTitleTAG = "DrBill Logo";
  // Image Link
  $rssImageLinkTAG  = "http://www.DrBill.CC";
  // Set the "maxFeeds" variable to the number of podcasts you want displayed
  // in the feed when it is accessed... in this way, you can limit the number
  // shown, speeding up execution.
  $maxFeeds         = "25";
  // Set the "enclosurePrefix" variable to allow stats analysis via an external provider, such as Raw Voice Media's TechPodcasts or Blubrry Stats System.  Leave as '' for no enclosure.
  $enclosurePrefix  = 'http://media.techpodcasts.com/curmudgeon/' ;

  // Allowed File Types in Feed URL
  $sftypes = "(.mp3 .m4a .m4b .asf .wma .avi .mov .mp4)";
  $goodParam = 1;
  if ( isSet( $_GET ) ){ // for later versions of PHP
    if ( !empty( $_GET[ 'ft' ] ) ){
      $useft = $_GET[ 'ft' ];
      $t = '.' . $useft;
      if ( strPos( strToLower( $sftypes ) , strToLower( $t ) ) === False ){
        $goodParam = 0;
      }
      $sftypes = "(." . strToLower($useft) . ")";
    }else{
      if ( isSet( $HTTP_GET_VARS ) ){ //for eairler versions of php
        if ( !empty( $HTTP_GET_VARS['ft'] ) ){
          $useft = $HTTP_GET_VARS['ft'];
          $t = '.' . $useft;
          if ( strPos( strToLower( $sftypes ) , strToLower( $t ) ) === False ){
            $goodParam = 0;
          }
          $sftypes = "(." . strToLower($useft) . ")";
        }
      }
    }
  }

  // location of the "getid3" library - should be the default unless you changed
  // it in your directory structure.
  $id3LibPath       = "./lib_getid3/getid3/getid3.php";
  // file extension of itme override file
  $descriptionsFileType = '.txt';
  // Delimiter
  $delim1 = ' ';
  //---------------------------------------------------------------------------
  // iTunes specific tags below - See iTunes RSS feed tech info for details at:
  // http://www.apple.com/itunes/store/podcaststechspecs.html#_Toc526931674
  // iTunes specific tags
  //---------------------------------------------------------------------------
  $nameSpaceTAG   = "http://www.itunes.com/dtds/podcast-1.0.dtd";
  //-- Explict Tag options: "yes" = IS Explicit, "no" = Not saying one way or
  //-- another, "clean" = Is a "G" rated clean feed suitable for kids.
  $explicitTAG    = "clean";
  $summaryTAG     = "Tech Tips, Tech News, the Web and other various musings from Dr. Bill Bailey at Dr. Bill Bailey.NET.  Join Dr. Bill as he makes pointed, funny, and sometimes, controversial observations on Tech Life.";
  $authorTAG      = "Dr. Bill Bailey";
  $ownerNameTAG   = "Dr. Bill Bailey";
  $ownerEmailTAG  = "DrBill@DrBill.CC";
  $topCategoryTAG = "Technology";
  $subCategoryTAG = "Tech News";
  $keywordTAG     = "Bill Bailey, Dr. Bill Bailey, computers, systems, open source, linux, windows, web, internet, tech, technology, tech news, computer, curmudgeon";
  $imageUrlTAG    = "http://www.DrBill.CC/images/DrBillImage144.gif";
  $imageTitleTAG  = "DrBill Logo";
  $imageLinkTAG   = "http://www.DrBill.CC";
  $imageItemTAG   = "no";
  //============================================================================
  //
  // end of DirCaster Variables.
  //
  //============================================================================
  //
  // Do not edit anything below this line unless you know what you are doing!
  //
  /* Main Code ****************************************************************/

  require_once($id3LibPath);

  // lets make all of the user set variables xml compliant just in case
  $titleTAG         = escChars ($titleTAG);
  $descriptionTAG   = escChars ($descriptionTAG);
  $copyrightTAG     = escChars ($copyrightTAG);
  $languageTAG      = escChars ($languageTAG);
  $webMasterTAG     = escChars ($webMasterTAG);
  $generatorTAG     = escChars ($generatorTAG);;
  $rssImageTitleTAG = escChars ($rssImageTitleTAG);
  $summaryTAG       = escChars ($summaryTAG);
  $authorTAG        = escChars ($authorTAG);
  $ownerNameTAG     = escChars ($ownerNameTAG);
  $ownerEmailTAG    = escChars ($ownerEmailTAG);
  $topCategoryTAG   = escChars ($topCategoryTAG);
  $subCategoryTAG   = escChars ($subCategoryTAG);
  $keywordTAG       = escChars ($keywordTAG);
  $imageTitleTAG    = escChars ($imageTitleTAG);

  $aItemsEmpty = array( 'title'           => '',
                        'link'            => '',
                        'author'          => '',
                        'commentText'     => '',
                        'commentCDATA'    => '',
                        'pubDate'         => '',
                        'enclosureURL'    => '',
                        'enclosureLength' => '',
                        'enclosureType'   => '',
                        'subtitle'        => '',
                        'keywords'        => '',
                        'imageURL'        => '',
                        'imageTitle'      => '',
                        'duration'        => '',
                        'guid'            => '',
                        'artist'          => '',
                        'album'           => '',
                        'composer'        => '',
                        'genre'           => '',
                        'year'            => '',
                        'track'           => '',
                        'copyright'       => '',
                        'summary'         => ''
                      );

  header('Content-type: text/xml', true);
  $rootMP3URL = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
  $rootMP3URL =  substr($rootMP3URL, 0, strrpos ($rootMP3URL, "/")); // Trim off script name itself
  // Add enclosure prefix if valued (ie TPN stats)
  $rootMP3URL = $enclosurePrefix . $rootMP3URL ;

  print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  print "<rss xmlns:itunes=\"$nameSpaceTAG\" version=\"2.0\">\n";

  print" <channel>\n";
  // original dircaster channel info
  if ($NEWfeedURL_ON == "yes") {
    print"     <itunes:new-feed-url>$NEWfeedURL</itunes:new-feed-url>\n";
  }
  print"  <title>$titleTAG</title>\n";
  print"  <link>$linkTAG</link>\n";

  // Alter description if file tye request is bad
  if ( !$goodParam ){
    print"  <description>Requested type is not supported (sftypes).</description>\n";
  }else{
    print"  <description>$descriptionTAG</description>\n";
  }

  print"  <category>$topCategoryTAG</category>\n";
  print"  <pubDate>" . fixDate( date("r") ) ."</pubDate>\n";
  print"  <lastBuildDate>" . fixDate( date("r") ) ."</lastBuildDate>\n";
  print"  <language>$languageTAG</language>\n";
  print"  <copyright>$copyrightTAG</copyright>\n";
  print"  <generator>$generatorTAG</generator>\n";
  print"  <managingEditor>$ownerEmailTAG ($ownerNameTAG)</managingEditor>\n";
  print"  <webMaster>$webMasterTAG</webMaster>\n";
  print"  <ttl>$ttlTAG</ttl>\n";

  // new itunes channel stuff
  // itunes author tag
  print"  <itunes:author>$authorTAG</itunes:author>\n";
  // itune subtitle tag
  print"  <itunes:subtitle>$descriptionTAG</itunes:subtitle>\n";
  // itunes category tags
  print"  <itunes:category text=\"".$topCategoryTAG."\">\n";
  print"    <itunes:category text=\"".$subCategoryTAG."\"/>\n";
  print"  </itunes:category>\n";
  // itunes summary tag
  print"  <itunes:summary>$summaryTAG</itunes:summary>\n";
  // iTunes channel keywords
  echo (" <itunes:keywords>$keywordTAG</itunes:keywords>\n");
  // itunes owner tags
  print"  <itunes:owner>\n";
  print"  <itunes:name>$ownerNameTAG</itunes:name>\n";
  print"  <itunes:email>$ownerEmailTAG</itunes:email>\n";
  print"  </itunes:owner>\n";
  // itunes explicit tag
  print"  <itunes:explicit>$explicitTAG</itunes:explicit>\n";
  // image tags
  print"  <itunes:image href=\"$rssImageUrlTAG\" />\n";
  print"  <image>\n";
  print"    <url>".$rssImageUrlTAG."</url>\n";
  print"    <title>".$rssImageTitleTAG."</title>\n";
  print"    <link>".$rssImageLinkTAG."</link>\n";
  print"  </image>\n";

  // Trailing tags for bad request
  if ( !$goodParam ){
    print "</channel>\n</rss>\n";
    exit();
  }

  // item listing
  $dirArray = getDir(".", $sftypes); // Get a list of the current directory
  while ( list($filename, $filedate ) = each($dirArray) AND $maxFeeds > 0) {
    $mp3file = new CMP3File;
    $mp3file->getid3 ($filename);
    echo "  <item>\n";

    $descriptiveFileName = stripType( $delim1, $sftypes, $filename ) .
                           $descriptionsFileType;
    $aItems = $aItemsEmpty;
    if ( file_exists( $descriptiveFileName ) ){
      getDescriptions( $descriptiveFileName, &$aItems ); // alters aItems
    }

    // item title
    if ( $aItems[ 'title' ] == '' ){
      // title tag
      $title = str_replace("_", " ", $mp3file->title);
      //handle empty title in id3 tag
      if ( empty( $title ) ){
        //use file name, drop file extension
        $title = stripType( $delim1, $sftypes, $filename );
      }
      //handle '&' in names
      $title = htmlentities( $title );
    }else{
      //title from descriptions file
      $title = $aItems[ 'title' ];
    }
    echo ("    <title>".$title."</title>\n"); // title string

    // item link
    if ( $aItems[ 'link' ] == '' ){
      $url = $rootMP3URL."/". htmlentities(str_replace(" ", "%20", $filename));
    }else{
      $url = $aItems[ 'link' ];
    }
    echo ("    <link>".$url."</link>\n"); //link string

    // item artist
    if ( $aItems[ 'artist' ] == '' ){
      $artist = $mp3file->artist;
    }else{
      $artist = $aItems[ 'artist' ];
    }

    // item author
    if ( $aItems[ 'author' ] == '' ){
      $author = $ownerEmailTAG;
    }else{
      $author = $aItems[ 'author' ];
    }
    echo ("    <author>$author</author>\n");

    //album
    if ( $aItems[ 'album' ] == '' ){
      $album = $mp3file->album;
    }else{
      $album = $aItems[ 'album' ];
    }

    //composer
    if ( $aItems[ 'composer' ] == '' ){
      $composer = $mp3file->composer;
    }else{
      $composer = $aItems[ 'composer' ];
    }

    //genre
    if ( $aItems[ 'genre' ] == '' ){
      $genre = $mp3file->genre;
    }else{
      $genre = $aItems[ 'genre' ];
    }

    //year
    if ( $aItems[ 'year' ] == '' ){
      $year = $mp3file->year;
    }else{
      $year = $aItems[ 'year' ];
    }

    //track
    if ( $aItems[ 'track' ] == '' ){
      $track = '';
    }else{
      $track = $aItems[ 'track' ];
    }

    //coyright
    if ( $aItems[ 'copyright' ] == '' ){
      $copyright = $mp3file->copyright;
    }else{
      $copyright = $aItems[ 'copyright' ];
    }

    // item description
    if ( $aItems[ 'commentText' ] == '' ){
      $description = "$title";
      if ( !empty( $album ) ){
        $description .= " - $album";
      }
      if ( !empty( $artist ) ){
        $description .= " - $artist";
      }
    }else{
      $description = $aItems[ 'commentText' ];
    }

    // description override, if commentCDATA is present
    if ( $aItems[ 'commentCDATA' ] != '' ){
      $description = $aItems[ 'commentCDATA' ];
    }
    echo ("    <description>$description</description>\n");

    // item pubDate
    if ( $aItems[ 'pubDate' ] == '' ){
      $pubdate = fixDate( date("r", $filedate) );
    }else{
      $pubdate = $aItems[ 'pubDate' ];
    }
    echo ("    <pubDate>$pubdate</pubDate>\n");

    // item enclosure
    if ( $aItems[ 'enclosureURL' ] == '' ){
      $enclosure = "\"" . $url . "\" length=\"" . filesize($filename) . "\" type=\"$mp3file->mime_type\"";
    }else{
      if ( $aItems[ 'enclosureLength' ] == '' ){
        $enclosureLength = " length=\"" . filesize($filename) . "\"";
      }else{
        $enclosureLength = " length=\"" . $aItems[ 'enclosureLength' ] . "\"";
      }
      if ( $aItems[ 'enclosureType' ] == '' ){
        $enclosureType = " type=\"$mp3file->mime_type\"";
      }else{
        $enclosureType = " type=\"" . $aItems[ 'enclosureType' ] . "\"";
      }
      $enclosure = $aItems[ 'enclosureURL' ] . $enclosureLength . $enclosureType;
    }
    echo ("    <enclosure url=$enclosure />\n");

    // item author
    if ( $aItems[ 'author' ] == '' ){
     $author = $artist;
    }else{
     $author = $aItems[ 'author' ];
    }
    echo ("    <itunes:author>$author</itunes:author>\n");


    // item summary
    if ( $aItems[ 'summary' ] == '' ){
      $summary = $mp3file->comment;
    }else{
      $summary = $aItems[ 'summary' ];
    }
    echo ("    <itunes:summary>$summary</itunes:summary>\n");

    // item subtitle
    if ( $aItems[ 'subtitle' ] == '' ){
      $subtitle = $mp3file->comment;
    }else{
      $subtitle = $aItems[ 'subtitle' ];
    }
    echo ("    <itunes:subtitle>$subtitle</itunes:subtitle>\n");

    // item keywords
    if ( $aItems[ 'keywords' ] == '' ){
      $keywords = $keywordTAG;
    }else{
      $keywords = $aItems[ 'keywords' ];
    }
    echo ("    <itunes:keywords>$keywords</itunes:keywords>\n");

    // item image
    // check to see if we want image info for each item
    if ($imageItemTAG == "yes") {
      if ( $aItems[ 'image' ] == '' ){
        $imageURL   = $imageUrlTAG;
        $imageTitle = $imageTitleTAG;
      }else{
        $imageURL   = $aItems[ 'imageURL' ];
        $imageTitle = $aItems[ 'imageTitle' ];
      }
      echo ("    <itunes:link rel=\"image\" type=\"video/jpeg\" href=\"$imageURL\">$imageTitle</itunes:link>\n");
    }

    // item duration
    $fix_duration = $mp3file->duration;
    if (strlen($fix_duration) < 3) {
      $fix_duration = "00:00:".$fix_duration;
    }
    if (strlen($fix_duration) < 6) {
      $fix_duration = "00:".$fix_duration;
    }
    $fix_duration = str_replace( ':0:', ':00:', $fix_duration );
    $fix_duration = str_replace( ':1:', ':01:', $fix_duration );
    $fix_duration = str_replace( ':2:', ':02:', $fix_duration );
    $fix_duration = str_replace( ':3:', ':03:', $fix_duration );
    $fix_duration = str_replace( ':4:', ':04:', $fix_duration );
    $fix_duration = str_replace( ':5:', ':05:', $fix_duration );
    $fix_duration = str_replace( ':6:', ':06:', $fix_duration );
    $fix_duration = str_replace( ':7:', ':07:', $fix_duration );
    $fix_duration = str_replace( ':8:', ':08:', $fix_duration );
    $fix_duration = str_replace( ':9:', ':09:', $fix_duration );

    // item duration
    if ( $aItems[ 'duration' ] == '' ){
      $duration = $fix_duration;
    }else{
      $duration = $aItems[ 'duration' ];
    }
    echo ("    <itunes:duration>$duration</itunes:duration>\n");

    // item guid
    if ( $aItems[ 'guid' ] == '' ){
      $guid = $linkTAG . '/' . $filename. '#' . $filedate;
    }else{
      $guid = $aItems[ 'guid' ];
    }
    echo ("    <guid isPermaLink=\"false\">" . $guid . "</guid>\n");

    // itme close
    print "  </item>\n";
    $maxFeeds--;
  }// end while

  // channel close / rss close
  print "</channel>\n</rss>\n";

  //---------------------------------------------------
  // Functions and Classes
  //---------------------------------------------------
  function fixDate( $filedate ){
    // patch for dates reurned with 1 digit day of month with leading space
    if ( strPos( $filedate, '  ' ) !== FALSE ){
      // version 1 - this dros one space ('  4' = ' 4') and works in the validator
      //$filedate = str_replace( '  ', ' ', $filedate );
      // version 2 replaces the space with a 0 ( '  4' = ' 04')
      $filedate = str_replace( 'Sun,  ', 'Sun, 0', $filedate );
      $filedate = str_replace( 'Mon,  ', 'Mon, 0', $filedate );
      $filedate = str_replace( 'Tue,  ', 'Tue, 0', $filedate );
      $filedate = str_replace( 'Wed,  ', 'Wed, 0', $filedate );
      $filedate = str_replace( 'Thu,  ', 'Thu, 0', $filedate );
      $filedate = str_replace( 'Fri,  ', 'Fri, 0', $filedate );
      $filedate = str_replace( 'Sat,  ', 'Sat, 0', $filedate );
    }
    return $filedate;
  }//end function

  function stripType( $delim, $types, $str ){
    // strip file extensions form file name per $sfTypes string
    $types = str_replace( '(', '', $types );
    $types = str_replace( ')', '', $types );
    $aTypes = explode( $delim, $types );

    $cnt = count( $aTypes );
    for ( $i = 0; $i < $cnt; $i++ ){
      $str = str_replace( $aTypes[ $i ], '', $str );
    }

    return $str;
  }// end function

  function stripJunk ($text) {
    // Strip non-text characters
    $outText = '';
    for ($c=0; $c<strlen($text); $c++) {
      if ( ord($text[$c] ) >= 32 AND ord( $text[$c] ) <= 122 )
        $outText.=$text[$c];
    }// end for
    return $outText;
  }// end function

  function escChars ($text) {
    // Strip non-text characters
    $fixed = str_replace("&","&#38;", $text);
    $fixed = str_replace("<","&#60;",$fixed);
    $fixed = str_replace("","&#169;",$fixed);
    $outText = str_replace(">","&#62;",$fixed);
    return $outText;
  }

  class CMP3File {
    //properties
    var $title;
    var $artist;
    var $album;
    var $year;
    var $comment;
    var $genre;
    var $composer;
    var $copyright;
    var $mime_type;
    var $duration;

    function getid3 ($file) {

      $tit  = '';
      $cmp  = '';
      $alb  = '';
      $com  = '';
      $art  = '';
      $mim  = '';
      $dur  = '';

      // Initialize getID3 engine
      if ( file_exists($file) ) {
        //after verifying the file exists,
        $getID3 = new getID3;

        // Analyze file and store returned data in $ThisFileInfo
        $ThisFileInfo = $getID3->analyze($file);

        // Optional: copies data from all subarrays of [tags] into [comments] so
        // metadata is all available in one location for all tag formats
        // metainformation is always available under [tags] even if this is not called
        getid3_lib::CopyTagsToComments($ThisFileInfo);

        // Output desired information in whatever format you want
        // Note: all entries in [comments] or [tags] are arrays of strings
        // See structure.txt for information on what information is available where
        // or check out the output of /demos/demo.browse.php for a particular file
        // to see the full detail of what information is returned where in the array
        //echo @$ThisFileInfo['comments']['artist'][0]; // artist from any/all available tag formats

        $mim = @$ThisFileInfo['mime_type']; // artist from any/all available tag formats
        $dur = @$ThisFileInfo['playtime_string']; // play duration from any/all available tag formats

        switch (strrchr(strtolower($file), ".")) {
          case ".mp3";
            $tit = @$ThisFileInfo['id3v2']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['id3v2']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['id3v2']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['id3v2']['comments']['comments'][0];
            $cmp = @$ThisFileInfo['id3v2']['comments']['composer'][0]; // artist from any/all available tag formats
            $gen = @$ThisFileInfo['id3v2']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".m4a";
            $tit = @$ThisFileInfo['quicktime']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['quicktime']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['quicktime']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['quicktime']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['quicktime']['comments']['writer'][0]; // artist from any/all available tag formats
            // $gen = @$ThisFileInfo['quicktime']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".m4b";
            $tit = @$ThisFileInfo['quicktime']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['quicktime']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['quicktime']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['quicktime']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['quicktime']['comments']['writer'][0]; // artist from any/all available tag formats
            // $gen = @$ThisFileInfo['quicktime']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".mov";
            $tit = @$ThisFileInfo['quicktime']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['quicktime']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['quicktime']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['quicktime']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['quicktime']['comments']['director'][0]; // artist from any/all available tag formats
            // $gen = @$ThisFileInfo['quicktime']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".asf";
            $tit = @$ThisFileInfo['asf']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['asf']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['asf']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['asf']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['asf']['comments']['composer'][0]; // artist from any/all available tag formats
            $gen = @$ThisFileInfo['asf']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          case ".wma";
            $tit = @$ThisFileInfo['asf']['comments']['title'][0]; // artist from any/all available tag formats
            $alb = @$ThisFileInfo['asf']['comments']['album'][0]; // artist from any/all available tag formats
            $art = @$ThisFileInfo['asf']['comments']['artist'][0]; // artist from any/all available tag formats
            $com = @$ThisFileInfo['asf']['comments']['comment'][0]; // artist from any/all available tag formats
            $cmp = @$ThisFileInfo['asf']['comments']['composer'][0]; // artist from any/all available tag formats
            $gen = @$ThisFileInfo['asf']['comments']['genre'][0]; // artist from any/all available tag formats
            break;
          default;
            $tit = $file; // artist from any/all available tag formats
        }// end switch

        $this->title = stripJunk($tit);
        $this->composer = stripJunk($cmp);
        $this->album = stripJunk($alb);
        $this->comment = stripJunk($com);
        $this->copyright = stripJunk($cmp);
        $this->artist = stripJunk($art);
        $this->mime_type = stripJunk($mim);
        $this->duration = stripJunk($dur);
        return true;
      }else{
        return false; // file doesn't exist
      }// end if
    }//end funtion
  }// end class

  function getDir($mp3Dir, $supported_file_types) {
    // Returns directory as array[file]=date in newest to oldest order
    $dirArray = array();
    $diskdir = "./$mp3Dir/";
    if (is_dir($diskdir)) {
      $dh = opendir($diskdir);
      while (($file = readdir($dh)) != false ) {
        if (filetype($diskdir . $file) == "file" && $file[0]  != ".") {
          $fext = strrchr(strtolower($file), ".");
          if (strpos ($supported_file_types, $fext) > 0) {
            $ftime = filemtime($mp3Dir."/".$file);
            $dirArray[$file] = $ftime;
          }
        }
      }// end while
      closedir($dh);
    }
    asort($dirArray);
    $dirArray = array_reverse($dirArray);
    return $dirArray;
  }// end fuction

  function getDescriptions( $filename, $aItems ){

    $delm = '`';

    $aLines = file( $filename );
    $cdata = 0;
    foreach ( $aLines as $line_num => $line ) {
      $line = trim( $line );

      //ignore comments
      if ( subStr( $line, 0, 1 ) == '#' ){
        continue;
      }

      if ( ( $foundAt = strPos( $line, ']' ) ) !== False ){
        $type = subStr( $line, 0, $foundAt +1 );
        $str  = subStr( $line, $foundAt +1 );

        switch ( $type ){
          case '[title]':
            $aItems[ 'title' ] = $str;
            break;
          case '[link]':
            $aItems[ 'link' ] = $str;
            break;
          case '[author]':
            $aItems[ 'author' ] = $str;
            break;
          case  '[commentText]':
            $aItems[ 'commentText' ] = $str;
            break;
          case '[pubDate]':
            $aItems[ 'pubDate'] = $str;
            break;
          case '[enclosureURL]':
            $aItems[ 'enclosureURL' ] = $str;
            break;
          case '[enclosureLength]':
            $aItems[ 'enclosureLength' ] = $str;
            break;
          case '[enclosureType]':
            $aItems[ 'enclosureType' ] = $str;
            break;
          case '[subtitle]':
            $aItems[ 'subtitle' ] = $str;
            break;
          case '[keywords]':
            $aItems[ 'keywords' ] = $str;
            break;
          case '[imageURL]':
            $aItems[ 'imageURL' ] = $str;
            break;
          case '[imageTitle]':
            $aItems[ 'imageTitle' ] = $str;
            break;
          case '[duration]':
            $aItems[ 'duration' ] = $str;
            break;
          case '[guid]':
            $aItems[ 'guid' ] = $str;
            break;
          case '[artist]':
            $aItems[ 'artist' ] = $str;
            break;
          case '[album]':
            $aItems[ 'album' ] = $str;
            break;
          case '[composer]':
            $aItmes[ 'composer' ] = $str;
            break;
          case '[genre]':
            $aItems[ 'genre' ] = $str;
            break;
          case '[year]':
            $aItmes[ 'year' ] = $str;
            break;
          case  '[track]':
            $aItmes[ 'track' ] = $str;
            break;
          case '[copyright]':
            $aItems[ 'copyright' ] = $str;
            break;
          case '[summary]':
            $aItems[ 'summary' ] = $str;
            break;
          case '[commentCDATA]':
            if ( !$cdata ){
              $cdata = 1;
              $aItems[ 'commentCDATA' ] = $str;
            }
            break;
          default:
            if ( $cdata ){
              $aItems[ 'commentCDATA' ] .= $str;
            }
        }// end switch
      }else{
        if ( $cdata ){
          $aItems[ 'commentCDATA' ] .= $line;
        }
      }// if

    }//foreach

    if ( $aItems[ 'commentCDATA' ] != '' ){
      $aItems[ 'commentCDATA' ] = '<![CDATA[' . $aItems[ 'commentCDATA' ] .= "]]>";
    }

  }//en function

  /*
  Current iTunes category listings
  (Major Categories followed by Sub-Categories shown by asterisks below the Major Category)

  Arts
      * Design
      * Fashion & Beauty
      * Food
      * Literature
      * Performing Arts
      * Visual Arts

  Business
      * Business News
      * Careers
      * Investing
      * Management & Marketing
      * Shopping
  Comedy
  Education
      * Education Technology
      * Higher Education
      * K-12
      * Language Courses
      * Training
  Games & Hobbies
      * Automotive
      * Aviation
      * Hobbies
      * Other Games
      * Video Games
  Government & Organizations
      * Local
      * National
      * Non-Profit
      * Regional
  Health
      * Alternative Health
      * Fitness & Nutrition
      * Self-Help
      * Sexuality
  Kids & Family
  Music
  News & Politics
  Religion & Spirituality
      * Buddhism
      * Christianity
      * Hinduism
      * Islam
      * Judaism
      * Other
      * Spirituality
  Science & Medicine
      * Medicine
      * Natural Sciences
      * Social Sciences
  Society & Culture
      * History
      * Personal Journals
      * Philosophy
      * Places & Travel
  Sports & Recreation
      * Amateur
      * College & High School
      * Outdoor
      * Professional
  Technology
      * Gadgets
      * Tech News
      * Podcasting
      * Software How-To
  TV & Film
  */

?>
